<?PHP

#######################
# Module: Top News
# Developed by IMP
# IranDatalife.com
#######################


if( !defined( 'DATALIFEENGINE' ) ) {
	header( 'HTTP/1.1 403 Forbidden' );
	header ( 'Location: ../../' );
	die( 'Hacking attempt!' );
}

//Create images folder
if( !is_dir( ROOT_DIR . '/uploads/imp_top_news/' ) ) {
  @mkdir(ROOT_DIR . '/uploads/imp_top_news/', 0777 );
  @chmod(ROOT_DIR . '/uploads/imp_top_news/', 0777 );
}

//Replace english numbers with farsi
function Farsi_Numbers( $String ) {
  $Find = array( '0','1','2','3','4','5','6','7','8','9' );
  $Replace = array( '۰','۱','۲','۳','۴','۵','۶','۷','۸','۹' );
  return str_replace( $Find, $Replace, $String );
}

//Get counter values
define( 'DATABASE_FILE', ENGINE_DIR . '/modules/imp_top_news/history.txt' );
$Data_File = unserialize( file_get_contents( DATABASE_FILE ) );
$News_Limit = intval( $limit ) ? $limit : '10';

//Check file date
$Today_Date = jdate( 'Ymd' );
$Is_New_Day = ( $Data_File['TODAY_DATE'] === $Today_Date ) ? false : true;

//Delete old files
if ( $Is_New_Day || !is_array( $Data_File ) ) array_map( 'unlink', array_filter( ( array ) glob( ROOT_DIR . '/uploads/imp_top_news/*' ) ) );

//Get news information
$News_ID = intval( $_GET['newsid'] );

//Create new database values
if ( $News_ID ) {

  //Get news information from database
  $DB_News = $db->super_query( "SELECT id, title, date, alt_name FROM " . PREFIX . "_post WHERE id = '$News_ID'" );
  $News_Date = strtotime( $DB_News['date'] );
  
  //Get news image information from database
  $DB_Image = $db->super_query( "SELECT images FROM " . PREFIX . "_images WHERE news_id= '{$DB_News['id']}'" );
  
  //Get image values
  if ( $DB_Image['images'] ) {
    $temp_Images = explode( '|||', $DB_Image['images'] );
    $temp_Image = explode( '/', $temp_Images['0'] );
    $Image_Name = $temp_Image['1'];

    if ( !file_exists( ROOT_DIR . '/uploads/imp_top_news/' . $temp_Image['1'] ) ) {
      require_once ENGINE_DIR . '/classes/thumb.class.php';
      $thumb = new thumbnail( ROOT_DIR . '/uploads/posts/' . $temp_Images['0'] );
      $thumb->jpeg_quality( '85' );
      $thumb->size_auto( '100x100' );
      $thumb->save( ROOT_DIR . '/uploads/imp_top_news/' . $temp_Image['1'] );
    }
  } else {
    $Image_Name = 'NA';
  }

  if ( $Is_New_Day || !is_array( $Data_File ) ) {
    $Data_File = array(
      'TODAY_DATE' => jdate( 'Ymd' ),
      'NEWS_LIST' => array(
        $DB_News['id'] => array(
          'NEWS_ID' => $DB_News['id'],
          'NEWS_SEO' => $DB_News['alt_name'],
          'NEWS_VIEWS' => '1',
          'NEWS_DATE' => $News_Date,
          'NEWS_TITLE' => $DB_News['title'],
          'NEWS_IMAGE' => $Image_Name
        )
      )
    );
  }

  else {
    $Updated_Count = $Data_File['NEWS_LIST'][$DB_News['id']]['NEWS_VIEWS']+1;
    $Data_File['NEWS_LIST'][$DB_News['id']] = array(
      'NEWS_ID' => $DB_News['id'],
      'NEWS_SEO' => $DB_News['alt_name'],
      'NEWS_VIEWS' => $Updated_Count,
      'NEWS_DATE' => $News_Date,
      'NEWS_TITLE' => $DB_News['title'],
      'NEWS_IMAGE' => $Image_Name
    );
  }

} else {

 if ( $Is_New_Day ) $Data_File = false;

}

//Submit new data to the text file
file_put_contents( DATABASE_FILE, serialize( $Data_File ), LOCK_EX );

//Calculate total views
$Total_Views = array_sum( array_column( $Data_File['NEWS_LIST'], 'NEWS_VIEWS' ) );

//Sort data
usort( $Data_File['NEWS_LIST'], function( $Item_B, $Item_A ) {

  if ($Item_A['NEWS_VIEWS'] == $Item_B['NEWS_VIEWS']) return 0;
  return $Item_A['NEWS_VIEWS'] < $Item_B['NEWS_VIEWS'] ? -1 : 1;

} );

//Generate new template
$tpl_a = new dle_template();
$tpl_a->dir = ROOT_DIR . '/engine/modules/imp_top_news/';

//News title template
$Count_Titles = '0';
$tpl_a->load_template( 'template_titles.tpl' );
foreach( array_slice( $Data_File['NEWS_LIST'], 0, $News_Limit ) as $Key => $Value ) {

  if ( $Value['NEWS_TITLE'] ) {

    //Generate news link
    if ( $config['allow_alt_url'] ) {
      $News_Link = $config['http_home_url'] . $Value['NEWS_ID'] . "-" . $Value['NEWS_SEO'] . ".html";
    } else {
      $News_Link = $config['http_home_url'] . "index.php?newsid=" . $Value['NEWS_ID'];
    }

    $Count_Titles++;
    $tpl_a->set( '{news-rank}', Farsi_Numbers( $Count_Titles ) );
    $tpl_a->set( '{news-title}', $Value['NEWS_TITLE'] );
    $tpl_a->set( '{news-views}', Farsi_Numbers( $Value['NEWS_VIEWS'] ) );
    $tpl_a->set( '{news-date}', Farsi_Numbers( jdate( 'j F Y', $Value['NEWS_DATE'] ) ) );
    $tpl_a->set( '{news-link}', $News_Link );
    $tpl_a->set( '{news-image}', ( $Value['NEWS_IMAGE'] != 'NA' ) ? $config['http_home_url'] . 'uploads/imp_top_news/' . $Value['NEWS_IMAGE'] . '?' . time() : $config['http_home_url'] . 'engine/skins/images/imp_top_news_noimg.png' );
    $tpl_a->compile( 'top_today_titles' );

  }

}

//Main template
$tpl_a->load_template( 'template_main.tpl' );
  $tpl_a->copy_template = '<!--IMP Top News Plugin :: IranDatalife.om-->' . $tpl_a->copy_template;
  $tpl_a->set( '{news-list}', $Count_Titles ? $tpl_a->result['top_today_titles'] : 'هیچ اطلاعاتی موجود نمیباشد' );

  if ( $Total_Views ) {
    $tpl_a->set( '[total-views]', '' );
    $tpl_a->set( '[/total-views]', '' );
    $tpl_a->set( '{total-views}', $Total_Views );
  } else {
    $tpl_a->set( '{total-views}', '' );
    $tpl_a->set_block( "'\\[total-views\\](.*?)\\[/total-views\\]'si", '' );
  }

$tpl_a->compile( 'top_today' );
$tpl_a->clear();

echo $tpl_a->result['top_today'];